#include <windows.h>
#include <stdio.h>
#include <commctrl.h>

#define ID_STATUS 100

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 085",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           480,                 /* Ancho */
           215,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static BOOL numlock;
    static HBITMAP hBitmapSi;
    static HBITMAP hBitmapNo;
    static HBITMAP hBitmapCoor;
    DRAWITEMSTRUCT *dis;
    HDC memDC;
    RECT re;
    int anchura[4];
    POINT ptCur;
    char cad[40];

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
           hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
           CreateStatusWindow(WS_CHILD|WS_VISIBLE, "Texto de prueba", hwnd, ID_STATUS);
           numlock = (GetKeyState(VK_NUMLOCK) & 1) == 1;
           hBitmapSi = LoadBitmap(hInstance, "Si");
           hBitmapNo = LoadBitmap(hInstance, "No");
           hBitmapCoor = LoadBitmap(hInstance, "Coor");
           return 0;
        case WM_SIZE:
           GetClientRect(hwnd, &re);
           anchura[3] = re.right-20;
           anchura[2] = anchura[3]-20;
           anchura[1] = anchura[2]-80;
           anchura[0] = anchura[1]-60;
           SendDlgItemMessage(hwnd, ID_STATUS, SB_SETPARTS, 4, (LPARAM)anchura);
           SendDlgItemMessage(hwnd, ID_STATUS, msg, wParam, lParam);
           if(numlock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3|SBT_OWNERDRAW, (LPARAM)hBitmapSi);
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3|SBT_OWNERDRAW, (LPARAM)hBitmapNo);
           break;
        case WM_MOUSEMOVE:
           SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 2|SBT_OWNERDRAW, lParam);
           break;
        case WM_DRAWITEM:
           dis = (DRAWITEMSTRUCT*)lParam;
           switch(dis->itemID) {
             case 2:
               memDC = CreateCompatibleDC(dis->hDC);
               SelectObject(memDC, hBitmapCoor);
               ptCur.x = LOWORD(dis->itemData);
               ptCur.y = HIWORD(dis->itemData);
               sprintf(cad, "%ld,%ld", ptCur.x, ptCur.y);
               SetBkMode(dis->hDC, TRANSPARENT);
               TextOut(dis->hDC, dis->rcItem.left+20, dis->rcItem.top, cad, strlen(cad));
               BitBlt(dis->hDC, dis->rcItem.left, dis->rcItem.top, 16, 16, memDC, 0, 0, SRCCOPY);
               DeleteDC(memDC);
               break;
             case 3:
               memDC = CreateCompatibleDC(dis->hDC);
               SelectObject(memDC, (HBITMAP)dis->itemData);
               BitBlt(dis->hDC, dis->rcItem.left, dis->rcItem.top, 16, 16, memDC, 0, 0, SRCCOPY);
               DeleteDC(memDC);
               break;
             default:
               break;
           }
           break;
        case WM_KEYDOWN:
           numlock = (GetKeyState(VK_NUMLOCK) & 1) == 1;
           if(numlock) SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3|SBT_OWNERDRAW, (LPARAM)hBitmapSi);
           else SendDlgItemMessage(hwnd, ID_STATUS, SB_SETTEXT, 3|SBT_OWNERDRAW, (LPARAM)hBitmapNo);
          break;
        case WM_COMMAND:
           break;
        case WM_DESTROY:
           DeleteObject(hBitmapNo);
           DeleteObject(hBitmapSi);
           DeleteObject(hBitmapCoor);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

